﻿using Markdig;
using Markdig.Renderers;
using Markdig.Renderers.Html;
using Markdig.Renderers.Html.Inlines;
using System;

namespace Website.Markdig.Extensions {
	public class BlogRendererExtension : IMarkdownExtension {
		public void Setup(MarkdownPipelineBuilder pipeline) {

		}

		private static void ReplaceRenderer<T>(IMarkdownRenderer htmlRenderer, Func<T, IMarkdownObjectRenderer> newRenderer)
			where T : IMarkdownObjectRenderer {
			var originalObjectRenderer = htmlRenderer.ObjectRenderers.FindExact<T>();
			if (originalObjectRenderer != null)
				htmlRenderer.ObjectRenderers.Remove(originalObjectRenderer);
			htmlRenderer.ObjectRenderers.Add(newRenderer(originalObjectRenderer));
		}

		public void Setup(MarkdownPipeline pipeline, IMarkdownRenderer renderer) {
			if (!(renderer is HtmlRenderer))
				return;
			
			ReplaceRenderer<LinkInlineRenderer>(renderer, originalLinkRenderer => new BlogMediaRenderer(originalLinkRenderer));
			ReplaceRenderer<HeadingRenderer>(renderer, originalHeadingRenderer => new BlogHeadingRenderer(originalHeadingRenderer));
		}
	}
}
