using System.Text;
using System.Text.RegularExpressions;

namespace Website.Markdig.Extensions.HtmlGenerators {
	public class YouTubeEmbedHtmlGenerator : IEmbeddedHtmlGenerator {
		private static readonly Regex YoutubeLink = new Regex(@"https://w{0,3}\.?youtu(?:\.be/|be\.com/watch\?v=)+(.*)", RegexOptions.Compiled);

		public bool IsMatch(string url) => YoutubeLink.IsMatch(url);

		public string GenerateHtml(string url) {
			var youtubeMatch = YoutubeLink.Match(url);
			var html = new StringBuilder();
			html.Append(@"<div class=""video-container"">");
			html.Append($@"<iframe src=""https://www.youtube.com/embed/{youtubeMatch.Groups[1].Value}"" title=""YouTube video player"" frameborder=""0"" allow=""accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"" allowfullscreen></iframe>");
			html.Append(@"</div>");
			return html.ToString();
		}
	}
}