﻿using System.Net.Http;
using System.Threading.Tasks;
using Microsoft.Extensions.Caching.Memory;
using Robware.Lib.ApiClient;
using Website.Models.Auth;

namespace Website.Data {
	public class AuthenticationProvider : ApiClient, IAuthenticationProvider {
		public AuthenticationProvider(HttpClient client, IMemoryCache cache, CacheDurations cacheDurations) : base(client, cache, cacheDurations) {
		}

		public async Task<User> Authenticate(LoginRequest request) {
			try {
				return await Post<User>("user/authenticate", request);
			}
			catch (ApiCallException) {
				return null;
			}
		}
	}
}